/*
SRSBDownloadController.h

Author: Makoto Kinoshita

Copyright 2004 The Shiira Project. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted 
provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions 
  and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of 
  conditions and the following disclaimer in the documentation and/or other materials provided 
  with the distribution.

THIS SOFTWARE IS PROVIDED BY THE SHIIRA PROJECT ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE SHIIRA PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
POSSIBILITY OF SUCH DAMAGE.
*/

#import <Cocoa/Cocoa.h>
#import <WebKit/WebKit.h>
#import "Shiira.h"

@class SRDownloadViewController;
@class SRDownloadHistoryItem;

@interface SRSBDownloadController : NSResponder
{
    SRMainWindowController*     _mainWindowController;
    SRSideBarController*        _sideBarController;
    SRDownloadViewController*   _downloadViewController;
    
    NSArray*                    _findResults;
    
    BOOL                        _isUpperViewSizeInitialized;
    
    IBOutlet id _downloadView;
    IBOutlet id _splitView;
    IBOutlet id _upperView;
    IBOutlet id _lowerView;
    
    IBOutlet id _historyTab;
    IBOutlet id _historyOutline;
    IBOutlet id _historySearchField;
    IBOutlet id _historyFindTable;
    IBOutlet id _historyImage;
    IBOutlet id _historyNameTextField;
    IBOutlet id _historyURLTextField;
    IBOutlet id _historyRefURLTextField;
    IBOutlet id _historyRefURLButton;
}

// Initialize
- (id)initWithMainWindowController:(SRMainWindowController*)mainWindowController 
        sideBarController:(SRSideBarController*)sideBarController;

// Controller
- (SRMainWindowController*)mainWindowController;
- (void)setMainWindowController:(SRMainWindowController*)mainWindowController;
- (SRSideBarController*)sideBarController;
- (void)setSidebarController:(SRSideBarController*)sideBarController;

// View
- (NSView*)view;

// Download
- (NSArray*)selectedDownloadHistoryItems;
- (void)selectDownloadHistoryItemAtRow:(int)row;
- (void)reloadDownloadHistoryFindTable;

// Actions
- (void)findDownloadHistoryAction:(id)sender;

@end
